#include <list>
#include <iterator>

class StateGrid {
   public:
      //bool keep_system_active;
      //std::list<State* const> system;
      std::list<State* > grid;
      std::list<State* >::iterator inactive_dummy;
      std::list<State* >::iterator i;

      void sort(){
         std::list<State* >::iterator first_inactive_not_checked = inactive_dummy;
            ++first_inactive_not_checked;
         //i1 is the element after i
         std::list<State* >::iterator i1 = grid.begin();
         grid.push_front(0);
         i = grid.begin();
         while (i1 != inactive_dummy) {
            if (!(*i1)->is_active()){
               grid.splice( first_inactive_not_checked, grid, i1);
            } else {
               ++i;
            }
            i1 = i;
               ++i1;
          }
         grid.pop_front();
         i = i1 = first_inactive_not_checked;
            --i;
         while ( i1!=grid.end()){
            if ((*i1)->is_active()){
               grid.splice( inactive_dummy, grid, i1);
            } else {
               ++i;
            }
            i1 = i;
               ++i1;
         }
      }

      void accept(ALLEGRO_EVENT* aep){
         sort();
         for (i=grid.begin(); i!= inactive_dummy; ++i){
            //!! if *i->is_active(): een State hiervoor, kan deze hebben veranderd;
            (*i)->accept(aep);
         }
      }

      State* const create_state() {
         State* const nsp = new State;
         grid.push_back(nsp);
         return nsp;
      }
      //State* const add_system_state();

      void clear(){
         for(i=grid.begin();i!=grid.end();++i)
            delete *i;
         grid.push_front(new State);
         inactive_dummy = grid.begin();
      }

      StateGrid()
      {
         grid.push_front(new State);
         inactive_dummy = grid.begin();
      }

      ~StateGrid()
      {
         for(i=grid.begin();i!=grid.end();++i)
            delete *i;
      }
};